(ns document-storage.postgres.core-test
  (:require [clojure.test :refer :all]
            [document-storage.core :as ds]
            [document-storage.postgres.core :as dspostgres]
            [clojure.java.io :as io]
            [fipp.edn :refer [pprint] :rename {pprint fipp}]
            [document-storage.protocol :as dsprot]
            [environ.core :refer [env]]
            [document-storage.protocol-test :as protocol-tests]))

(def ds-atom (atom nil))

(defn storage-fixture [f]
  (reset! ds-atom
          (dspostgres/make-postgres-ds
           {:id :testing
            :repositories {:testrepo {:caching true}}
            :jdbc-url (env :database-url)}))
  (f)
  (.delete-repository @ds-atom :testrepo))

(use-fixtures :once storage-fixture)

(deftest simple-test
  (protocol-tests/test-save-document ds-atom))


(deftest versioning-test
    (protocol-tests/test-versioning ds-atom))

(deftest find-document-test
  (protocol-tests/test-find-documents ds-atom))


;;;TODO test if versioning/caching parameters are set correctly for new repositories
